// TLBBrowserDlg.h : header file
//

#if !defined(AFX_TLBBROWSERDLG_H__AC930967_7FF8_11D2_9D64_C16854832C76__INCLUDED_)
#define AFX_TLBBROWSERDLG_H__AC930967_7FF8_11D2_9D64_C16854832C76__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CTLBBrowserDlg dialog

#include "afxcoll.h"
#include "afxtempl.h"


class CTypeLibraryData
{

public:
	
	CString m_strCLSIDTypeLib;
	CString m_strDescription;
	long m_lMajorVersion;
	long m_lMinorVersion;
	

};


typedef CTypedPtrArray<CPtrArray, CTypeLibraryData*> TYPELIB_DATA;


class CTLBBrowserDlg : public CDialog
{
// Construction
public:
	CTLBBrowserDlg(CWnd* pParent = NULL);	// standard constructor
	~CTLBBrowserDlg();
// Dialog Data
	//{{AFX_DATA(CTLBBrowserDlg)
	enum { IDD = IDD_TLBBROWSER_DIALOG };
	CListCtrl	m_ListTypeAttribs;
	CListCtrl	m_ListTypeInfo;
	CListCtrl	m_ListCtrl;
	CString	m_strGUIDTLB;
	CString	m_strHelpString;
	CString	m_strHelpFile;
	CString	m_strErrorStatus;
	CString	m_strTypeHelpFile;
	CString	m_strTypeHelpString;
	CString	m_strTypeDescription;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTLBBrowserDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTLBBrowserDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClickTypeList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickTypeInfo(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	BOOL EnumerateRegistryForTypeLibEntries();
	BOOL GetInformationForTLB(DWORD dwIndex);
	BOOL  ExtractComponentsFromTLB(int iIndex);
	BOOL GetTypeInfoInformation(DWORD dwIndex);
	BOOL GetTypeAttributes();
	
	
	int m_nTLBListLastSelectedItem;
	TYPELIB_DATA m_arrayData;


	ITypeLib* m_pTypeLib;
	ITypeInfo* m_pCurrentTypeInfo;


	CImageList m_ImageList;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TLBBROWSERDLG_H__AC930967_7FF8_11D2_9D64_C16854832C76__INCLUDED_)
